---
title: Update an Entry
description: The PUT /directory/v1/{{dn}} endpoint modifies the entry specified by its distinguished name. Attribute values specified in the request body are updated; existing attributes omitted from the request maintain their current values. Attribute values set to null in the request body are removed from the entry.
component: pingdirectory
page_id: pingdirectory:directory:directory-entry-apis/update-an-entry
canonical_url: https://developer.pingidentity.com/pingdirectory/directory/directory-entry-apis/update-an-entry.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update an Entry

##

```none
PUT {{apiPath}}/directory/v1/{{dn}}
```

The `PUT /directory/v1/{{dn}}` endpoint modifies the entry specified by its distinguished name. Attribute values specified in the request body are updated; existing attributes omitted from the request maintain their current values. Attribute values set to `null` in the request body are removed from the entry.

Attributes designated for update are replaced entirely. You cannot partially modify an attribute. In addition, `PUT` operates exclusively on top-level attributes of the entity. If you wish to edit an attribute value within a JSON entity, you must replace the entire entity. Providing a null value for an attribute within a JSON entity removes the entity.

|   |                                                                                                                                                                                                                                                                                                                                                                                   |
| - | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | It is not possible to modify any API attributes such as `_links`, `_embedded`, or `_parentDN`. This operation will not work to update a user's `userPassword` or `authPassword` attributes due to a default `deny write` global ACI targeting these attributes. It is recommended to use the `{{apiPath}}/directory/v1/{{dn}}/changePassword+` endpoint to update passwords only. |

To update the DN of an entry, refer to [Rename or move an entry](rename-or-move-an-entry.html).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "cn": [
        "Linda Jones",
        "Linda F. Jones"
    ],
    "ubidEmailJSON": null
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/directory/v1/{{dn}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "cn": [
        "Linda Jones",
        "Linda F. Jones"
    ],
    "ubidEmailJSON": null
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/directory/v1/{{dn}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""cn"": [" + "\n" +
@"        ""Linda Jones""," + "\n" +
@"        ""Linda F. Jones""" + "\n" +
@"    ]," + "\n" +
@"    ""ubidEmailJSON"": null" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/directory/v1/{{dn}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "cn": [
        "Linda Jones",
        "Linda F. Jones"
    ],
    "ubidEmailJSON": null
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /directory/v1/{{dn}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "cn": [
        "Linda Jones",
        "Linda F. Jones"
    ],
    "ubidEmailJSON": null
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"cn\": [\n        \"Linda Jones\",\n        \"Linda F. Jones\"\n    ],\n    \"ubidEmailJSON\": null\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/directory/v1/{{dn}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/directory/v1/{{dn}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "cn": [
      "Linda Jones",
      "Linda F. Jones"
    ],
    "ubidEmailJSON": null
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/directory/v1/{{dn}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "cn": [
      "Linda Jones",
      "Linda F. Jones"
    ],
    "ubidEmailJSON": null
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/directory/v1/{{dn}}"

payload = json.dumps({
  "cn": [
    "Linda Jones",
    "Linda F. Jones"
  ],
  "ubidEmailJSON": None
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/directory/v1/{{dn}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "cn": [\n        "Linda Jones",\n        "Linda F. Jones"\n    ],\n    "ubidEmailJSON": null\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/directory/v1/{{dn}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "cn": [
    "Linda Jones",
    "Linda F. Jones"
  ],
  "ubidEmailJSON": "__RUBY\#%0NULL__"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"cn\": [\n        \"Linda Jones\",\n        \"Linda F. Jones\"\n    ],\n    \"ubidEmailJSON\": null\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/directory/v1/{{dn}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_dn": "entryUUID=a4fbd3ca-f7a0-42f2-af66-13f2c0dd8cd1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones",
        "Linda F. Jones"
    ],
    "sn": [
        "Jones"
    ],
    "_links": {
        "schemas": [
            {
                "href": "https://ds.example.com/directory/v1/schemas/inetOrgPerson"
            }
        ],
        "self": {
            "href": "https://ds.example.com/directory/v1/entryUUID=a4fbd3ca-f7a0-42f2-af66-13f2c0dd8cd1,ou=people,dc=example,dc=com"
        }
    }
}
```
